﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace SynchronisedScrolling
{
    public partial class Form1 : Form
    {
        DataSet dataSet1;

        public Form1()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;
            this.Text = "Synchronised Scrolling with Three WinGrids";
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            dataSet1 = new DataSet();
            dataSet1.ReadXml(@"...\...\Customers.xml");
            ultraGrid1.DataSource = dataSet1;
            ultraGrid2.DataSource = dataSet1;
            ultraGrid3.DataSource = dataSet1;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.GroupByBox.Hidden = true;
            ultraGrid1.Font = new Font("Microsoft Sans Serif", 9.25F);
            e.Layout.CaptionVisible = DefaultableBoolean.False;
            e.Layout.Override.RowSelectors = DefaultableBoolean.True;
            e.Layout.Override.ActiveRowAppearance.BackColor = Color.Tan;
            e.Layout.Override.ActiveRowAppearance.ForeColor = Color.Black;
            e.Layout.Override.HeaderAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.HeaderStyle = HeaderStyle.Standard;
            e.Layout.Override.HeaderAppearance.FontData.Bold = DefaultableBoolean.True;
            e.Layout.Bands[0].Override.HeaderAppearance.TextHAlign = HAlign.Center;
            e.Layout.Override.RowSelectorAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.BorderStyleCell = UIElementBorderStyle.InsetSoft;

            e.Layout.Bands[0].Columns["ContactName"].Hidden = true;
            e.Layout.Bands[0].Columns["Address"].Hidden = true;
            e.Layout.Bands[0].Columns["City"].Hidden = true;
            e.Layout.Bands[0].Columns["Country"].Hidden = true;
            //e.Layout.Scrollbars = Scrollbars.None;
            e.Layout.ScrollBarLook.VerticalScrollBarWidth = 1;
        }

        private void ultraGrid2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.GroupByBox.Hidden = true;
            ultraGrid2.Font = new Font("Microsoft Sans Serif", 9.25F);
            e.Layout.CaptionVisible = DefaultableBoolean.False;
            e.Layout.Override.RowSelectors = DefaultableBoolean.True;
            e.Layout.Override.ActiveRowAppearance.BackColor = Color.Tan;
            e.Layout.Override.ActiveRowAppearance.ForeColor = Color.Black;
            e.Layout.Override.HeaderAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.HeaderStyle = HeaderStyle.Standard;
            e.Layout.Override.HeaderAppearance.FontData.Bold = DefaultableBoolean.True;
            e.Layout.Bands[0].Override.HeaderAppearance.TextHAlign = HAlign.Center;
            e.Layout.Override.RowSelectorAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.BorderStyleCell = UIElementBorderStyle.InsetSoft;

            e.Layout.Bands[0].Columns["CustomerID"].Hidden = true;
            e.Layout.Bands[0].Columns["CompanyName"].Hidden = true;
            e.Layout.Bands[0].Columns["City"].Hidden = true;
            e.Layout.Bands[0].Columns["Country"].Hidden = true;
            //e.Layout.Scrollbars = Scrollbars.None;
            e.Layout.ScrollBarLook.VerticalScrollBarWidth = 1;
        }

        private void ultraGrid3_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.ScrollStyle = ScrollStyle.Immediate;
            e.Layout.GroupByBox.Hidden = true;
            ultraGrid3.Font = new Font("Microsoft Sans Serif", 9.25F);
            e.Layout.CaptionVisible = DefaultableBoolean.False;
            e.Layout.Override.RowSelectors = DefaultableBoolean.True;
            e.Layout.Override.ActiveRowAppearance.BackColor = Color.Tan;
            e.Layout.Override.ActiveRowAppearance.ForeColor = Color.Black;
            e.Layout.Override.HeaderAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.HeaderStyle = HeaderStyle.Standard;
            e.Layout.Override.HeaderAppearance.FontData.Bold = DefaultableBoolean.True;
            e.Layout.Bands[0].Override.HeaderAppearance.TextHAlign = HAlign.Center;
            e.Layout.Override.RowSelectorAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.BorderStyleCell = UIElementBorderStyle.InsetSoft;

            e.Layout.Bands[0].Columns["CustomerID"].Hidden = true;
            e.Layout.Bands[0].Columns["CompanyName"].Hidden = true;
            e.Layout.Bands[0].Columns["ContactName"].Hidden = true;
            e.Layout.Bands[0].Columns["Address"].Hidden = true;
        }

        private void ultraGrid3_BeforeRowRegionScroll(object sender, BeforeRowRegionScrollEventArgs e)
        {
            ultraGrid2.ActiveRowScrollRegion.ScrollPosition = e.NewState.ScrollPosition -1;
            ultraGrid1.ActiveRowScrollRegion.ScrollPosition = e.NewState.ScrollPosition -1;
        }

        private void ultraGrid1_Enter(object sender, EventArgs e)
        {
            ultraGrid1.Focus();
        }

        private void ultraGrid1_BeforeRowRegionScroll(object sender, BeforeRowRegionScrollEventArgs e)
        {
            ultraGrid3.Focus();
        }

        private void ultraGrid2_Enter(object sender, EventArgs e)
        {
            ultraGrid2.Focus();
        }

        private void ultraGrid2_BeforeRowRegionScroll(object sender, BeforeRowRegionScrollEventArgs e)
        {
            ultraGrid3.Focus();
        }

        private void ultraGrid3_Enter(object sender, EventArgs e)
        {
            ultraGrid3.Focus();
        }
    }
}
